//
//  ViewController.swift
//  Example
//
//  Created by Shivangi Goel on 23/12/21.
//

import UIKit
import GluedInSDK

class ViewController: UIViewController, GluedInDelegate {
    
    var gluedinRootcontroller = UIViewController()

    func appSessionEvent(deviceID: String, platformName: String) {
        print("appSessionEvent")
    }
    
    func appLaunchEvent(deviceID: String, platformName: String) {
        print("appLaunchEvent")
    }
    
    func appScreenViewEvent(Journey_entry_point: String, user_email: String, user_name: String, page_name: String) {
        print("appScreenViewEvent")
    }
    
    func appLoginCTAClickEvent(device_ID: String, user_email: String, user_name: String, user_isFollow: String, user_following_count: String, user_follower_count: String, platform_name: String, page_name: String) {
        print("appLoginCTAClickEvent")
    }
    
    func appRegisterCTAClickEvent(device_ID: String, user_email: String, user_name: String, user_isFollow: String, user_following_count: String, user_follower_count: String, platform_name: String, page_name: String) {
        print("appRegisterCTAClickEvent")
    }
    
    func appSkipLoginEvent(device_ID: String, platform_name: String, page_name: String) {
        print("appSkipLoginEvent")
    }
    
    func appTabClickEvent(Journey_entry_point: String, device_ID: String, user_email: String, user_name: String, platform_name: String, page_name: String, tab_name: String) {
        print("appTabClickEvent")
    }
    
    func appUserFollowEvent(user_isFollow: String, user_following_count: String, user_follower_count: String, page_name: String, tab_name: String, element: String, button_type: String) {
        print("appUserFollowEvent")
    }
    
    func appUserUnFollowEvent(user_isFollow: String, user_following_count: String, user_follower_count: String, page_name: String, tab_name: String, element: String, button_type: String) {
        print("appUserUnFollowEvent")
    }
    
    func appThumbnailClickEvent(page_name: String, tab_name: String, vertical_index: String, horizontal_index: String, element: String, content_type: String, content_genre: String) {
        print("appThumbnailClickEvent")
    }
    
    func appSearchButtonClickEvent(page_name: String, tab_name: String, search_query: String, results_returned: String) {
        print("appSearchButtonClickEvent")
    }
    
    func appViewMoreEvent(Journey_entry_point: String, device_ID: String, user_email: String, user_name: String, platform_name: String, page_name: String, tab_name: String, element: String, button_type: String) {
        print("appViewMoreEvent")
    }
    
    func appChallengeJoinEvent(page_name: String, tab_name: String, element: String, button_type: String) {
        print("appChallengeJoinEvent")
    }
    
    func appPopupCTAsEvent(page_name: String, tab_name: String, element: String, button_type: String, popup_name: String) {
        print("appPopupCTAsEvent")
    }
    
    func appChallengeShareClickEvent(device_ID: String, user_email: String, user_name: String, platform_name: String, page_name: String, tab_name: String, element: String, button_type: String, success: String, failure_reason: String, creator_userid: String, creator_username: String) {
        print("appChallengeShareClickEvent")
    }
    
    func appUseThisHashtagEvent(device_ID: String, user_email: String, user_name: String, platform_name: String, page_name: String, tab_name: String, element: String, button_type: String, hashtag: String, content_type: String, content_genre: String) {
        print("appUseThisHashtagEvent")
    }
    
    func appViewLeaderboardEvent(Journey_entry_point: String, device_ID: String, user_email: String, user_name: String, platform_name: String, page_name: String, tab_name: String, element: String, button_type: String) {
        print("appViewLeaderboardEvent")
    }
    
    func callClientSignInView() {
        print("callClientSignInView")
    }
    
    func callClientSignUpView() {
        print("callClientSignUpView")
    }
    
    func didSelectBack() {
        print("didSelectBack")
    }
    
    func didSelectParentApp() {
        print("didSelectParentApp")
        self.gluedinRootcontroller.navigationController?.popViewController(animated: true)
    }
    

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
    }

    override func viewWillAppear(_ animated: Bool) {
//        GluedIn.shared.initSdk {
//            let gluedinTab:UITabBarController = GluedIn.shared.rootTabController() ?? UITabBarController()
//            self.navigationController?.pushViewController(gluedinTab, animated: true)
//        } failure: { error, code in
//            print(error)
//        }
    }

    
    @IBAction func launchGluedinTabAsGuest(_ sender: Any) {
        GluedIn.shared.initSdk {
            let gluedinTab:UITabBarController = GluedIn.shared.rootTabController() ?? UITabBarController()
            self.navigationController?.pushViewController(gluedinTab, animated: true)
        } failure: { error, code in
            print(error)
        }
    }
    
    
    @IBAction func launchGluedinAuthScreen(_ sender: Any) {
        GluedIn.shared.initSdk {
            self.gluedinRootcontroller =  GluedIn.shared.rootControllerWithSignIn(delegate: self) ?? UIViewController()
            self.navigationController?.pushViewController(self.gluedinRootcontroller, animated: true)
        } failure: { error, code in
            print(error)
        }
    }

    
    @IBAction func registerUserAndlaunchGluedin(_ sender: Any) {
        GluedIn.shared.initSdk {
            GluedIn.shared.quickLaunch(email: "amitch184@gmail.com",
                                       password: "123456789",
                                       firebaseToken: "",
                                       deviceId: "1234",
                                       deviceType: "ios",
                                       fullName: "amit",
                                       autoCreate: true,
                                       termConditionAccepted: true,
                                       delegate: self) { [weak self] vw in
                guard let weakSelf = self else { return }
                weakSelf.navigationController?.pushViewController(vw ?? UIViewController(), animated: true)
            } failure: { err,arg  in
                print(err)
                print(arg)
            }
        } failure: { err,arg  in
            print(err)
            print(arg)
        }
    }
    
//    func didSelectParentApp() {
//        print("func didSelectParentApp()")
//    }
}

//extension GluedInDelegate {
//    func appSessionEvent(deviceID: String,
//                         platformName: String) ->() {}
//
//    func appLaunchEvent(deviceID: String,
//                        platformName: String) ->() {}
//
//    func appScreenViewEvent(Journey_entry_point: String,
//                            user_email: String,
//                            user_name: String,
//                            page_name: String) ->() {}
//
//    func appLoginCTAClickEvent(device_ID: String,
//                            user_email: String,
//                            user_name: String,
//                            user_isFollow: String,
//                            user_following_count: String,
//                            user_follower_count: String,
//                            platform_name: String,
//                               page_name: String) ->() {}
//
//    func appRegisterCTAClickEvent(device_ID: String,
//                            user_email: String,
//                            user_name: String,
//                            user_isFollow: String,
//                            user_following_count: String,
//                            user_follower_count: String,
//                            platform_name: String,
//                                  page_name: String) ->() {}
//
//    func appSkipLoginEvent(device_ID: String,
//                            platform_name: String,
//                           page_name: String) ->() {}
//
//    func appTabClickEvent(Journey_entry_point: String,
//                            device_ID: String,
//                            user_email: String,
//                            user_name: String,
//                            platform_name: String,
//                            page_name: String,
//                          tab_name : String) ->() {}
//
//    func appUserFollowEvent(user_isFollow: String,
//                            user_following_count: String,
//                            user_follower_count: String,
//                            page_name: String,
//                            tab_name : String,
//                            element: String,
//                            button_type: String) ->() {}
//
//    func appUserUnFollowEvent(user_isFollow: String,
//                              user_following_count: String,
//                              user_follower_count: String,
//                              page_name: String,
//                              tab_name : String,
//                              element: String,
//                              button_type: String) ->() {}
//
//    func appThumbnailClickEvent(page_name: String,
//                            tab_name: String,
//                            vertical_index: String,
//                            horizontal_index: String,
//                            element: String,
//                            content_type: String,
//                                content_genre: String) ->() {}
//
//    func appSearchButtonClickEvent(page_name: String,
//                            tab_name: String,
//                            search_query: String,
//                                   results_returned: String) ->() {}
//
//    func appViewMoreEvent(Journey_entry_point: String,
//                          device_ID: String,
//                          user_email: String,
//                          user_name: String,
//                          platform_name: String,
//                          page_name: String,
//                          tab_name : String,
//                          element: String,
//                          button_type: String) ->() {}
//
//    func appChallengeJoinEvent(page_name: String,
//                            tab_name: String,
//                            element: String,
//                               button_type: String) ->() {}
//
//    func appPopupCTAsEvent(page_name: String,
//                            tab_name: String,
//                            element: String,
//                            button_type: String,
//                           popup_name: String) ->() {}
//
//    func appChallengeShareClickEvent(device_ID: String,
//                            user_email: String,
//                            user_name: String,
//                            platform_name: String,
//                            page_name: String,
//                            tab_name: String,
//                            element: String,
//                            button_type: String,
//                            success: String,
//                            failure_reason: String,
//                            creator_userid: String,
//                                     creator_username: String) ->() {}
//
//    func appUseThisHashtagEvent(device_ID: String,
//                            user_email: String,
//                            user_name: String,
//                            platform_name: String,
//                            page_name: String,
//                            tab_name: String,
//                            element: String,
//                            button_type: String,
//                            hashtag: String,
//                            content_type: String,
//                                content_genre: String) ->() {}
//
//    func appViewLeaderboardEvent(Journey_entry_point: String,
//                                 device_ID: String,
//                                 user_email: String,
//                                 user_name: String,
//                                 platform_name: String,
//                                 page_name: String,
//                                 tab_name : String,
//                                 element: String,
//                                 button_type: String) ->() {}
//    func callClientSignInView() ->() {
//
//    }
//
//    func callClientSignUpView() ->() {
//
//    }
//
//    func didSelectBack()->() {
//
//    }
//
//    func didSelectParentApp() -> () {
//        print("in extension didSelectParentApp")
//    }
//}
